;; GETFONTS.LSP - a program to extract a list of fonts 
;; from a drawing to an external file
;; Copyright 1996 by Tony Hotchkiss
;**************************************
(defun err (s)
(if (= s "Function cancelled")
(princ "\nGETFONTS cancelled.")
(progn (princ "\nGETFONTS Error: ") (princ s) (terpri)) )
(resetting)
(princ "SYSTEM VARIABLES have been reset\n") (princ)
); err
(defun setv (systvar newval / xname)
(setq xname (read (strcat systvar "1"))) (set xname (getvar systvar))
(setvar systvar newval)
); setv
(defun rsetv (systvar / xname)
(setq xname (read (strcat systvar "1"))) (setvar systvar (eval xname))
); restv
(defun setting ()
(setq oerr *error*)
(setq *error* err)
(setv "CMDECHO" 0)
(setv "BLIPMODE" 0)
); end of setting
(defun input (/ i used-style-list total-style-list ss not-used-list 
new-used-list x)
(setq i (- 1)
used-style-list nil
total-style-list nil
)
(setq ss (ssget "X" '((-4 . "<OR")
(0 . "TEXT") (0 . "MTEXT")
(0 . "INSERT") (0 . "DIMENSION")
(-4 . "OR>"))
); ssget
); setq
(setq used-style-list (make-used-list ss)) (setq total-style-list (make-total-list)) (setq not-used-list nil)
(setq new-used-list nil)
(foreach x total-style-list
(if (not (member (car x) used-style-list)) 
(setq not-used-list (append not-used-list (list x))) (setq new-used-list (append new-used-list (list x))) ); if
); foreach
(output new-used-list not-used-list)
); input
(defun make-used-list (ss / ulist ename etype style-name) 
(setq ulist nil)
(repeat (sslength ss)
(setq ename (ssname ss (setq i (1+ i)))) (setq etype (cdr (assoc 0 (entget ename)))) (setq style-name
(cond
((= etype "TEXT") (text-style ename))
((= etype "MTEXT") (mtext-style ename))
((= etype "DIMENSION") (dimenstext-style ename)) ((= etype "INSERT") (attribtext-style ename)) ); cond
)
(if (listp style-name)
(setq ulist (append ulist style-name))
(setq ulist (append ulist (list style-name))) ); if
); repeat
(setq ulist (condense-list ulist))
); make-used-list
(defun text-style (ename / sname)
(setq sname (cdr (assoc 7 (entget ename)))) ); text-style
(defun mtext-style (ename / sname)
(setq sname (cdr (assoc 7 (entget ename)))) ); mtext-style
(defun dimenstext-style (ename / blkname blklist elist sname) 
(setq blkname (cdr (assoc 2 (entget ename)))) (setq blklist (tblsearch "BLOCK" blkname)) (setq ename (entnext (cdr (assoc -2 blklist)))) (while ename
(setq elist (entget ename))
(if (= (cdr (assoc 0 elist)) "TEXT")
(progn
(setq sname (cdr (assoc 7 elist)))
(setq ename nil)
); progn
(setq ename (entnext ename))
); if
); while
sname
); dimenstext-style
(defun attribtext-style (ename / elist flag66 snamelist estyle) 
(setq elist (entget ename))
(setq flag66 (cdr (assoc 66 elist)))
(if (= (logand flag66 1) 1)
(progn
(setq snamelist nil)
(while (/= (cdr (assoc 0 (entget ename))) "SEQEND") 
(setq estyle nil)
(setq ename (entnext ename))
(setq estyle (cdr (assoc 7 (entget ename)))) (if estyle (setq snamelist
(append snamelist (list estyle))
); setq
); if
); while
); progn
); if
snamelist
); attribtext-style
(defun condense-list (ulist / newlist)
(setq newlist nil)
(foreach item ulist
(if (not (member item newlist))
(setq newlist (append newlist (list item))) ); if
); foreach
newlist
); condense-list
(defun make-total-list (/ stylelist tblist 
stylename stylefile styledp)
(setq stylelist nil)
(setq tblist (tblnext "STYLE" T))
(while tblist
(setq stylename (cdr (assoc 2 tblist))
stylefile (cdr (assoc 3 tblist))
styledp (cons stylename stylefile)
stylelist (append stylelist (list styledp)) tblist (tblnext "STYLE")
)
); while
stylelist
); make-total-list
(defun output (lnew lold / dgn)
(setq f1 (open "fontfile.txt" "w"))
(setq dgn (getvar "DWGNAME"))
(princ
(strcat "THE FOLLOWING TEXT STYLES AND FILES ARE USED IN \n" 
dgn "\n") f1
)
(princ "\n STYLE        FONT-FILENAME\n" f1)
(prntout lnew)
(princ
(strcat
"\nTHE FOLLOWING TEXT STYLES AND FILES ARE NOT USED IN \n" 
dgn " AND MAY BE PURGED\n") f1
)
(princ "\n STYLE        FONT-FILENAME\n" f1)
(prntout lold)
(setq f1 (close f1))
); end of defun output
(defun prntout (lst / str chars x)
(foreach x lst
(setq chars (strlen (car x)))
(setq str (strcat (car x) (suffx (- 14 chars)) (cdr x))) (princ str f1) (princ "\n" f1)
)
); prntout
(defun suffx (num / xx)
(setq xx "")
(repeat num
(setq xx (strcat xx " "))
); repeat
); suffx
(defun resetting ()
(rsetv "CMDECHO")
(rsetv "BLIPMODE")
(setq *error* oerr)
); end of resetting
(defun c:getfonts ()
(setting)
(input)
(resetting)
(princ)
); end c:getfonts
