;Tip1237.LSP:     SET.LSP     Set SNAPBASE and SNAPANG     (c)1996, Watson Kilbourne

;; SETA sets SNAPANG to user defined angle in degrees
;; SETB sets SNAPBASE coordinates to user defined point
;; ZERO resets SNAPANG and SNAPBASE to default settings (0.0,0.0)
;;
(defun c:SETA (/ CA SA)
    (command "GRAPHSCR")
    (setq CA (rtos (/ (* (getvar "SNAPANG") 180) pi)))
    (print (strcat "Current SNAPANG is set to " CA " degrees"))
    (while (= SA nil)
       (setq SA (getreal "\nEnter new snap angle in degrees:  "))
    )
    (setvar "SNAPANG" (* pi (/ SA 180)))
    (prompt "\nSNAPANG is now set in degrees to: ")
    (/ (* (getvar "SNAPANG") 180) pi)
)
(defun c:SETB (/ CB SB X1 Y1)
    (command "GRAPHSCR")
    (setq CB (getvar "SNAPBASE"))
    (prompt "\nCurrent SNAPBASE coordinates are: ")
    (prin1 CB)
    (while (= SB nil)
       (setq SB (getpoint "\nPick or enter new base point: "))
    )
    (setq X1 (car SB))
    (setq Y1 (cadr SB))
    (setvar "SNAPBASE" (list X1 Y1))
    (prompt "\nNew x-y snapbase coordinates are: ")
    (getvar "SNAPBASE")
)
(defun c:ZERO ()
    (setvar "SNAPBASE" '(0.0 0.0))
    (setvar "SNAPANG" 0)
    (prompt "SNAPANG is reset to 0.0000, and SNAPBASE is reset to ")
    (getvar "SNAPBASE")
)
(princ "\nSETA, SETB and ZERO routines are now loaded....")
(princ)
