;Tip1238.LSP:     V.LSP     Dynamic Zoom and Pan     (c)1996, David Storey

;;; Dynamic Pan & zoom from the keyboard - for when ZOOM Dynamic doesn't
;;; quite do it for you.
;;; Note - Some platforms may return different grread values, you may have to
;;; experiment (This was written for R12 DOS).
;;; modified to work with  R12 Windows 5/21/96

(defun get_ky (/ val) ; Get the key code or return nil if ENTER or ESC.
   (setq val (grread nil 6 1))
   (if (or 
         (equal val (list 2 13)) ; ENTER from keyboard
         (equal val (list 6 0))  ; ENTER from Digitizer Puck
         (equal val (list 2 27)) ; ESCAPE
      )
      (setq val nil)
      (cadr val)
   )
)
(defun c:v (/ exp_val base_vc vc base_vs vs un ky nvc nvs)
   (setvar "cmdecho" 0) 
   (setq exp_val (getvar "expert"))
   (setvar "expert" 1)                     ; Ensure automatic regen if needed.
   (setq base_vc (getvar "viewctr"))
   (setq base_vs (getvar "viewsize"))
   (while (setq ky (get_ky))
      (setq vc (getvar "viewctr"))
      (setq vs (getvar "viewsize"))
      (setq un (/ vs 8))               ; Unit of movement = 1/8 screen height.
      (cond
         ((or (= ky 203) (= ky -6))
            (setq nvc (list (- (car vc) un) (cadr vc) 0.0) nvs "") ; Pan Left
         )
         ((or (= ky 205) (= ky -7))
            (setq nvc (list (+ (car vc) un) (cadr vc) 0.0) nvs "") ; Pan Right
         )
         ((or (= ky 200) (= ky -4))
            (setq nvc (list (car vc) (+ (cadr vc) un) 0.0) nvs "") ; Pan Up
         )
         ((or (= ky 208) (= ky -5))
            (setq nvc (list (car vc) (- (cadr vc) un) 0.0) nvs "") ; Pan Down
         )
         ((= ky 45)
            (setq nvc vc nvs (* vs 1.2)) ; Zoom Out
         )
         ((= ky 43)
            (setq nvc vc nvs (* vs 0.8)) ; Zoom In
         )
         ((or (= ky 199) (= ky 32) (= ky -2))
            (setq nvc base_vc nvs base_vs) ; Restore First View
         )
      )
      (command "_.zoom" "c" nvc nvs) 
   )
   (setvar "cmdecho" 0)
   (setvar "expert" exp_val)
   (princ)
)
(princ "\nUse Arrow keys to Pan, + or - to Zoom in and out, 
HOME to restore to original view, ENTER or ESC to Quit: ")
(princ)
